﻿namespace Turing
{
    public class Procesor
    {
        private Stan stan;
        private Kod kod;

        public Procesor(Stan stan, Kod kod)
        {
            this.stan = stan;
            this.kod = kod;
        }

        public bool WykonajKrok()
        {
            Czwórka? pasującaCzwórka = kod.ZnajdźPasującąCzwórkę(stan.StanGłowicy, stan.StanKomórkiPodGłowicą);
            if (pasującaCzwórka == null) return false;
            //TODO: sprawdzać, czy nie ma zapętlenia z jakimś limitem
            switch (pasującaCzwórka.NowyStanKomórki)
            {
                case 'L':
                    stan.PrzesuńGłowicęWLewo(pasującaCzwórka.NowyStanGłowicy);
                    break;
                case 'R':
                    stan.PrzesuńGłowicęWPrawo(pasującaCzwórka.NowyStanGłowicy);
                    break;
                default:
                    stan.ZmieńStanKomórkiPodGłowicą(pasującaCzwórka.NowyStanKomórki, pasującaCzwórka.NowyStanGłowicy);
                    break;
            }
            onWykonanyKrok(pasującaCzwórka, stan.ToString());
            return true;
        }

        #region Zdarzenie
        public class WykonanyKrokEventArgs : EventArgs
        {
            public Czwórka PasującaCzwórka;
            public string OpisAktualnegoStanu;
        }

        public delegate void WykonanyKrokEventHandler(object sender, WykonanyKrokEventArgs e);
        public event WykonanyKrokEventHandler WykonanyKrok;

        //public event EventHandler<TuringEventArgs> WykonanyKrok;

        public class ZakończonyProgramEventArgs : EventArgs
        {
            public int LiczbaWykonanychKroków;
        }

        public delegate void ZakończonyProgramEventHandler(object sender, ZakończonyProgramEventArgs e);
        public event ZakończonyProgramEventHandler ZakończonyProgram;

        protected void onWykonanyKrok(Czwórka pasującaCzwórka, string opisAktualnegoStanu)
        {
            WykonanyKrokEventArgs e = new WykonanyKrokEventArgs()
            {
                PasującaCzwórka = pasującaCzwórka,
                OpisAktualnegoStanu = opisAktualnegoStanu,
            };
            if(WykonanyKrok != null) WykonanyKrok(this, e);
        }

        protected void onZakończonyProgram(int liczbaWykonanychKroków)
        {
            if (ZakończonyProgram != null) ZakończonyProgram(this, new ZakończonyProgramEventArgs() { LiczbaWykonanychKroków = liczbaWykonanychKroków});
        }
        #endregion

        public void WykonajProgram()
        {            
            bool b;
            int liczbaWykonanychKroków = 0;
            do
            {
                b = WykonajKrok();
                if (b != false) liczbaWykonanychKroków++;
            }
            while (b);
            onZakończonyProgram(liczbaWykonanychKroków);
        }
    }
}
